/** @file
 * LWE device tree read API 
 */

/*
 * Copyright (c) 2008 - 2010 Freescale Semiconductor, Inc.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY Freescale Semiconductor ``AS IS'' AND ANY
 * EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL Freescale Semiconductor BE LIABLE FOR ANY
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
 * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */
#ifndef __LDT_H__
#define __LDT_H__

#include <types.h>
#include <cache.h>

#define MAX_ADDR_CELLS 2
#define MAX_SIZE_CELLS 2

struct dev_range {
	phys_addr_t chaddr;
	phys_addr_t phaddr;
	phys_addr_t chsize;
};

uint32_t get_tbfreq(void);
int get_stdout_handle(const char *alias_name, int *node_off);
int get_fdt_int(int node, const char *propname, int *val);
int get_fdt_irq(int node, int *irq, int *type);
int get_shutdn_dbell_irq(void);
uint32_t get_sec_core_mask(void);
int get_bootargs_coremask(uint32_t * mask);
int get_cache_blk_size(enum cache_type_t cache_type);

#endif /*__LDT_H__*/
