/** @file
 * mmap_private.h : Some functions related with tlb0 and ptov/vtop.
 */

/*
 * Copyright (c) 2009 Freescale Semiconductor, Inc.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY Freescale Semiconductor ``AS IS'' AND ANY
 * EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL Freescale Semiconductor BE LIABLE FOR ANY
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
 * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

#ifndef __MMAP_PRIVATE_H
#define __MMAP_PRIVATE_H

#define MAX_VTOP	64
#define MAX_TLB1	(cpu->tlb1cnt)

struct vtop_info {
	uint32_t memsz;
	uint32_t vaddr;
	phys_addr_t paddr;
};

struct addr_tbl {
	struct vtop_info entry[MAX_VTOP];
	int max_index;
};

struct tlbtbl_entry {
	uint32_t addr;
	uint32_t attr;
};

extern uint32_t _dev_mmap_start;

#define TLB0_VALID_MASK 0x80000000
#define TLB0_SIZE_MASK	0x000001ff
#define TLB0_RPN_MASK	0x00ffffff
#define TLB0_SIZE	0x00200000
#define PAGE_SIZE	0x1000
#define PAGE_SHIFT 12
#define WAY_MASK  0x3
#define DEV_MMAP_START	((uint32_t)&_dev_mmap_start)

#define TLB1_TSIZE_MASK	0x000f0000
#define TLB1_TSIZE_SHIFT 16
#define	TLB1_LAST_ENTRY 0x00100000
#define TLB1_VALID_MASK	0x80000000

void initialize_vptbl(uint32_t cpu_id);
void print_vptbl(void);
void alloc_vspace(void);
extern uint32_t get_freetlb1_idx(void);

#endif
