/*
 * Copyright (c) 2009, 2010 Freescale Semiconductor, Inc.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY Freescale Semiconductor ``AS IS'' AND ANY
 * EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL Freescale Semiconductor BE LIABLE FOR ANY
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
 * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

#ifdef __cplusplus
    extern "C" {
#endif

#ifndef REGISTER_CMD
#error Macro REGISTER_CMD not defined.
#endif

/** Format of the command to be added by the LWE modules/applications
 */

/*
REGISTER_CMD("<command-name>", <handler_function>, "<usage-information>") */

REGISTER_CMD("sld", shell_cmd_sld, "Set log destination");
REGISTER_CMD("plb", shell_cmd_plb, "Print log history buffer");
REGISTER_CMD("pll", shell_cmd_pll, "Print log levels");
REGISTER_CMD("sll", shell_cmd_sll, "Set log levels");
REGISTER_CMD("pmem", shell_cmd_pmem,
			"Shows memory dump "
			" from given physical address.");
REGISTER_CMD("vmem", shell_cmd_vmem,
			"Shows memory dump "
			" from given virtual address.");
REGISTER_CMD("ipc", shell_cmd_ipc,
			"Shows Instructions executed per cycle.");
REGISTER_CMD("profile_dcache", shell_cmd_profile_dcache,
			"Shows miss rate for L1 data cache");
REGISTER_CMD("profile_icache", shell_cmd_profile_icache,
			"Shows miss rate for L1 instruction cache");
REGISTER_CMD("sts", shell_cmd_sts, "Show timer status");
REGISTER_CMD("top", shell_cmd_top, "Show CPU Usage");
REGISTER_CMD("query_fq", shell_cmd_qman_query_fq, "Query Frame Queue");
REGISTER_CMD("query_fq_np", shell_cmd_qman_query_fq_np, "Query Frame Queue NP");
REGISTER_CMD("gcs", shell_cmd_get_core_state,
			 "Shows the state core is in"
			 "Nap, idle or running");

#ifdef __cplusplus
    }
#endif
