
/** @file shell.h
 * This file contains APIs for implementing LWE shell.
 * Shell is an interactive console, through which user
 * can enter various commands to get the info from LWE
 *
 * Shell will be available to each LWE core by default
 *
 */

/*
 * Copyright (c) 2009, 2010 Freescale Semiconductor, Inc.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY Freescale Semiconductor ``AS IS'' AND ANY
 * EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL Freescale Semiconductor BE LIABLE FOR ANY
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
 * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

#ifndef __SHELL_H
#define __SHELL_H

#ifdef __cplusplus
    extern "C" {
#endif
typedef int (*shell_cmd_cb_hndlr)(int argc, char *argv[]);

/** Linked list manipulation functions
 *  list contains the command nodes with
 *  their respective handler functions
 *
 *  add_command: Adds command nodes into the command's list
 *  param[in] char * Command name to add
 *  param[in] void * Pointer to command handler function
 *  param[in] char * Usage information of the Command
 *  return Negative - Failure
	Non-Negative - Success
 *  note Called every time to add a new command.
 */
int add_command(char *cmd, shell_cmd_cb_hndlr hndlr_func, char *usage_str);

#ifdef __cplusplus
    }
#endif
#endif
